<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCoveragePricedType ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfCoveragePricedType extends AbstractStructArrayBase
{
    /**
     * The PricedCoverage
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgCoveragePricedType[]
     */
    public $PricedCoverage;
    /**
     * Constructor method for ArrayOfCoveragePricedType
     * @uses DgArrayOfCoveragePricedType::setPricedCoverage()
     * @param \dgsoft\StructType\DgCoveragePricedType[] $pricedCoverage
     */
    public function __construct(array $pricedCoverage = array())
    {
        $this
            ->setPricedCoverage($pricedCoverage);
    }
    /**
     * Get PricedCoverage value
     * @return \dgsoft\StructType\DgCoveragePricedType[]|null
     */
    public function getPricedCoverage()
    {
        return $this->PricedCoverage;
    }
    /**
     * Set PricedCoverage value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgCoveragePricedType[] $pricedCoverage
     * @return \dgsoft\ArrayType\DgArrayOfCoveragePricedType
     */
    public function setPricedCoverage(array $pricedCoverage = array())
    {
        foreach ($pricedCoverage as $arrayOfCoveragePricedTypePricedCoverageItem) {
            // validation for constraint: itemType
            if (!$arrayOfCoveragePricedTypePricedCoverageItem instanceof \dgsoft\StructType\DgCoveragePricedType) {
                throw new \InvalidArgumentException(sprintf('The PricedCoverage property can only contain items of \dgsoft\StructType\DgCoveragePricedType, "%s" given', is_object($arrayOfCoveragePricedTypePricedCoverageItem) ? get_class($arrayOfCoveragePricedTypePricedCoverageItem) : gettype($arrayOfCoveragePricedTypePricedCoverageItem)), __LINE__);
            }
        }
        $this->PricedCoverage = $pricedCoverage;
        return $this;
    }
    /**
     * Add item to PricedCoverage value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgCoveragePricedType $item
     * @return \dgsoft\ArrayType\DgArrayOfCoveragePricedType
     */
    public function addToPricedCoverage(\dgsoft\StructType\DgCoveragePricedType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgCoveragePricedType) {
            throw new \InvalidArgumentException(sprintf('The PricedCoverage property can only contain items of \dgsoft\StructType\DgCoveragePricedType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PricedCoverage[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgCoveragePricedType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgCoveragePricedType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgCoveragePricedType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgCoveragePricedType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgCoveragePricedType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PricedCoverage
     */
    public function getAttributeName()
    {
        return 'PricedCoverage';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfCoveragePricedType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
